<?php
/*
Plugin Name: Stopper
Plugin URI: http://wppage.ru/
Description: 
Version: 2.0
Author: Виктор Левчук
Author URI: http://wppage.ru/
*/

function stopper_js_css_init()
{
	#PAGE IS ADMIN
	if(!is_admin()){
		wp_enqueue_script('jquery');
	
		}
		
	if(is_admin())
	{

		wp_register_style('metabox_style', plugins_url('/stopper.css', __FILE__));
		wp_enqueue_style('metabox_style');
		
		wp_register_script('metabox_script', plugins_url('/stopper.js', __FILE__));
		wp_enqueue_script('metabox_script');
		
		
	}
}
add_action('init', 'stopper_js_css_init');


//------------- register_activation_hook

function stopper_activate(){ 
	//file_put_contents(TEMPLATEPATH. '/editor-style.css', file_get_contents(plugins_url('/lib/editor-style.css', __FILE__)));
	//flush_rewrite_rules();
}
register_activation_hook( __FILE__, 'stopper_activate' );

// ------------------------------- Add the Meta Box
function add_stopper_metabox() {
	add_meta_box('stopper_extra_box', 'stopper', 'stopper_extra','page_selling', 'normal');	
	add_meta_box('stopper_extra_box', 'stopper', 'stopper_extra','post', 'normal');
	add_meta_box('stopper_extra_box', 'stopper', 'stopper_extra','page', 'normal');	
}
add_action( 'admin_init', 'add_stopper_metabox', 1 ); // add metabox

function stopper_extra() {
    global $post;


    
    // Noncename needed to verify where the data originated
    echo '<input type="hidden" name="stopper_metabox_noncename" id="stopper_metabox_noncename" value="' .
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';

    // Get the data if its already been entered
	$stopper_status = (get_post_meta($post->ID, '_stopper_status', true))? 'checked="checked"': '';
	$stopper_url = get_post_meta($post->ID, '_stopper_url', true);
	$stopper_text = get_post_meta($post->ID, '_stopper_text', true);
	$stopper_audio = get_post_meta($post->ID, '_stopper_audio', true);
	
	// Echo out the field
    ?>
	<div class="additional p_box p_content">
	    <a class="more_details" target="_blank" href="http://wppage.ru/stopper-lessons">Подробнее</a>
	<table>
		<tr>
			<td><label><input type="checkbox" id="stopper_status" name="stopper_status" <?php echo $stopper_status; ?> /> Включить stopper на этой странице</label><br /><br /></td>
		</tr>
		<tr>
			<td><label for="stopper_url">URL для переадресации</label><br /><input type="text" name="stopper_url" id="stopper_url" value="<?php echo $stopper_url; ?>" />
			</td>
		</tr>
		<?php if(get_post_type() == 'page_selling') {?>
		<tr>
			<td><label for="stopper_audio">Аудио<br /><input type="text" name="stopper_audio" id="stopper_audio" value="<?php echo $stopper_audio; ?>" /> </label></td>
		</tr>
		<?php } ?>
		<tr>
			<td>
			<label for="stopper_text">Текст сообщения</label><br />
		<textarea name="stopper_text" id="stopper_text"><?php echo $stopper_text; ?></textarea>
			</td>
		</tr>
		
	</table>

	</div>
  <?php
}

// Save the Data
 
function metabox_save($post_id, $post) {
 
    // verify this came from the our screen and with proper authorization,
    // because save_post can be triggered at other times
    if ( !wp_verify_nonce( $_POST['stopper_metabox_noncename'], plugin_basename(__FILE__) )) {
		return $post->ID;
    }
	
    // Is the user allowed to edit the post or page?
    if ( !current_user_can( 'edit_post', $post->ID )){
        return $post->ID;
	}
    // OK, we're authenticated: we need to find and save the data
    // We'll put it into an array to make it easier to loop though.
    $stopper_meta['_stopper_status'] = $_POST['stopper_status'];
	$stopper_meta['_stopper_url'] = $_POST['stopper_url'];
	$stopper_meta['_stopper_text'] = $_POST['stopper_text'];
	$stopper_meta['_stopper_audio'] = $_POST['stopper_audio'];

    // Add values of $sinus_meta as custom fields
 
	foreach ($stopper_meta as $key => $value) { // Cycle through the $sinus_meta array!
       // if( $post->post_type == 'revision' ) return; // Don't store custom data twice
        $value = implode(',', (array)$value); // If $value is an array, make it a CSV (unlikely)
        if(get_post_meta($post->ID, $key, FALSE)) { // If the custom field already has a value
            update_post_meta($post->ID, $key, $value);
        } else { // If the custom field doesn't have a value
            add_post_meta($post->ID, $key, $value);
        }
        if(!$value) delete_post_meta($post->ID, $key); // Delete if blank
    }
 
}
 
add_action('save_post', 'metabox_save', 1, 2); // save the custom fields

//-------------
add_action("wp_head", "add_stopper_audio");
add_action("wpp_head", "add_stopper_audio");
function add_stopper_audio(){ 
	global $post;
	if(get_post_type() == 'page_selling'): ?>
		<script type="text/javascript" src="<?php echo plugins_url()?>/stopper/js/sm/soundmanager2-jsmin.js"></script>
		<script type="text/javascript">
		j = jQuery.noConflict();
		j(function(){
			
			soundManager.url = '<?php echo plugins_url()?>/stopper/js/sm/swf/'; // directory where SM2 .SWFs live
			soundManager.debugMode = false;
			soundManager.onready(function(){
			  var stopper_sound = soundManager.createSound({
				id: 'stopper_sound',
				url: '<?php echo get_post_meta(get_the_ID(), '_stopper_audio', true); ?>', 
				autoLoad:true,
				
			  });
			});
			
			
			});
			
	</script>
<?php endif;
}

//-------------
add_action("wp_footer", "add_stopper");
add_action("wpp_footer", "add_stopper");
function add_stopper(){
	if(get_post_type() == 'page' || get_post_type() == 'post'):
		global $post;
		$stopper_status = get_post_meta($post->ID, '_stopper_status', true);
		$stopper_url = get_post_meta($post->ID, '_stopper_url', true);
		$stopper_text = get_post_meta($post->ID, '_stopper_text', true);
		$stopper_text = str_replace(array("\n", "\r"), array('\n', ''), $stopper_text); 
		if(get_post_meta($post->ID, '_stopper_status', true)=='on'){ ?>
			<script language="javascript">
				var exitsplashmessage = '<?php echo $stopper_text; ?>';
				var exitsplashpage = '<?php echo $stopper_url; ?>';
				function addLoadEvent(func) { var oldonload = window.onload; if (typeof window.onload != 'function') { window.onload = func; } else { window.onload = function() { if (oldonload) { oldonload(); } func(); }}}
				function addClickEvent(a,i,func) { if (typeof a[i].onclick != 'function') { a[i].onclick = func; } }
				var theDiv = '<div id="ExitSplashDiv" style="display:block; width:100%; height:100%; position:absolute; background:#FFFFFF; margin-top:0px; margin-left:0px;" align="center">';
				theDiv = theDiv + '<iframe src="'+exitsplashpage+'" width="100%" height="100%" align="middle" frameborder="0"></iframe>';
				theDiv = theDiv + '</div>';
				theBody = document.body; if (!theBody) {theBody = document.getElementById("body"); if (!theBody) {theBody = document.getElementsByTagName("body")[0];}}
				var PreventExitSplash = false;
				function DisplayExitSplash(){ if(PreventExitSplash == false){ window.scrollTo(0,0); PreventExitSplash=true; divtag = document.createElement("div"); divtag.setAttribute("id","ExitSplashMainOuterLayer"); divtag.style.position="absolute"; divtag.style.width="100%"; divtag.style.height="100%"; divtag.style.zIndex="99"; divtag.style.left="0px"; divtag.style.top="0px"; divtag.innerHTML=theDiv; theBody.innerHTML=""; theBody.topMargin="0px"; theBody.rightMargin="0px"; theBody.bottomMargin="0px"; theBody.leftMargin="0px"; theBody.style.overflow="hidden"; theBody.appendChild(divtag); return exitsplashmessage; } }
				var a = document.getElementsByTagName('A'); for (var i = 0; i < a.length; i++) { if(a[i].target !== '_blank') {addClickEvent(a,i, function(){ PreventExitSplash=true; });} else{addClickEvent(a,i, function(){ PreventExitSplash=false;});}}disablelinksfunc = function(){var a = document.getElementsByTagName('A'); for (var i = 0; i < a.length; i++) { if(a[i].target !== '_blank') {addClickEvent(a,i, function(){ PreventExitSplash=true; });} else{addClickEvent(a,i, function(){ PreventExitSplash=false;});}}}
				addLoadEvent(disablelinksfunc);
				disableformsfunc = function(){ var f = document.getElementsByTagName('FORM'); for (var i=0;i<f.length;i++){ if (!f[i].onclick){ f[i].onclick=function(){ PreventExitSplash=true; } }else if (!f[i].onsubmit){ f[i].onsubmit=function(){ PreventExitSplash=true; }}}}
				addLoadEvent(disableformsfunc);
				window.onbeforeunload = DisplayExitSplash;
			</script>
		
		<?php }
	endif;
	
} ?>